# SwaggerClient-php
Ingram Micro APIs for invoice management.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 5.0
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen
For more information, please visit [https://developer.ingrammicro.com/contact](https://developer.ingrammicro.com/contact)

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: application
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new Swagger\Client\Api\InvoicesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$invoice_number = "invoice_number_example"; // string | Ingram Micro Invoice Number
$customer_number = "20-222222"; // string | Your unique Ingram Micro customer number
$iso_country_code = "US"; // string | ISO 2 char country code

try {
    $result = $apiInstance->getInvoices($invoice_number, $customer_number, $iso_country_code);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling InvoicesApi->getInvoices: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*InvoicesApi* | [**getInvoices**](docs/Api/InvoicesApi.md#getinvoices) | **GET** /invoices/{invoiceNumber} | Get invoice details

## Documentation For Models

 - [AddressType](docs/Model/AddressType.md)
 - [InvoiceDetails](docs/Model/InvoiceDetails.md)
 - [InvoiceDetailsServiceresponse](docs/Model/InvoiceDetailsServiceresponse.md)
 - [InvoiceDetailsServiceresponseInvoicedetailresponse](docs/Model/InvoiceDetailsServiceresponseInvoicedetailresponse.md)
 - [InvoiceDetailsServiceresponseInvoicedetailresponseExtendedspecs](docs/Model/InvoiceDetailsServiceresponseInvoicedetailresponseExtendedspecs.md)
 - [InvoiceDetailsServiceresponseInvoicedetailresponseMiscfeeline](docs/Model/InvoiceDetailsServiceresponseInvoicedetailresponseMiscfeeline.md)
 - [InvoiceDetailsServiceresponseResponsepreamble](docs/Model/InvoiceDetailsServiceresponseResponsepreamble.md)
 - [ProductLineType](docs/Model/ProductLineType.md)
 - [ProductLineTypeSerialnumberdetails](docs/Model/ProductLineTypeSerialnumberdetails.md)
 - [ProductLineTypeTrackingnumberdetails](docs/Model/ProductLineTypeTrackingnumberdetails.md)

## Documentation For Authorization


## application

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - ****: 


## Author



