# Swagger\Client\InvoicesApi

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getInvoices**](InvoicesApi.md#getinvoices) | **GET** /invoices/{invoiceNumber} | Get invoice details

# **getInvoices**
> \Swagger\Client\Model\InvoiceDetails getInvoices($invoice_number, $customer_number, $iso_country_code)

Get invoice details

A request that allows the customer to query Ingram Micro for invoice details for a specific open or shipped order (in the past 9 months).  *NOTE: invoiceNumber, isoCountryCode and customerNumber is mandatory.*

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: application
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new Swagger\Client\Api\InvoicesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$invoice_number = "invoice_number_example"; // string | Ingram Micro Invoice Number
$customer_number = "20-222222"; // string | Your unique Ingram Micro customer number
$iso_country_code = "US"; // string | ISO 2 char country code

try {
    $result = $apiInstance->getInvoices($invoice_number, $customer_number, $iso_country_code);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling InvoicesApi->getInvoices: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **invoice_number** | **string**| Ingram Micro Invoice Number |
 **customer_number** | **string**| Your unique Ingram Micro customer number | [default to 20-222222]
 **iso_country_code** | **string**| ISO 2 char country code | [default to US]

### Return type

[**\Swagger\Client\Model\InvoiceDetails**](../Model/InvoiceDetails.md)

### Authorization

[application](../../README.md#application)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

